﻿Imports System
Imports System.Collections.Generic
Imports System.Linq
Imports System.Web
Imports System.Web.UI
Imports System.Web.UI.WebControls
Imports System.ServiceModel
Imports System.Security.Cryptography.X509Certificates
Imports System.Security.Principal
Imports MFA.WebControls
Imports SecureAuth.IdentityModel.WSFederation
Imports MFA.Utilities

Imports System.Collections

Partial Class WSFedSignOut
    Inherits System.Web.UI.Page

    Protected Sub Page_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load
       
        'Get wreply query string param and use is as the src for the iFrame to send wsignoutcleanup1.0 back to Office365
        Dim wreplycleanup As String = Request.QueryString("wreply")
        Dim f As HtmlGenericControl = New HtmlGenericControl("iframe")
        f.Attributes.Add("src", wreplycleanup)
        f.Attributes.Add("class", "iframeHide")
        phIFrame.Controls.Add(f)


        'Start restart.aspx logic to clear session, preauth, and postauth cookies. 
        FormsAuthentication.SignOut()
        Session.Clear()
        Session.Abandon()
        Session.RemoveAll()

        '' This clears the ASP.Net_SessionId to avoid Static Session ID attack
        Dim SessionTimeoutCookie As String = Tools.SessionTimeOutCookieName()

        If Not Request.Cookies(SessionTimeoutCookie) Is Nothing Then
            Response.Cookies(SessionTimeoutCookie).Value = String.Empty
            Response.Cookies(SessionTimeoutCookie).Expires = DateTime.Now.AddDays(-1)
        End If

        Dim PreAuthCookie As HttpCookie = Request.Cookies(ConfigurationManager.AppSettings("PreAuthCookieName"))
        If Not PreAuthCookie Is Nothing Then
            Tools.AddCookie(PreAuthCookie, DateTime.Now.AddDays(-1), "")
        End If
        Dim PostAuthCookie As HttpCookie = Request.Cookies(ConfigurationManager.AppSettings("PostAuthCookieName"))
        If Not PostAuthCookie Is Nothing Then
            Tools.AddCookie(PostAuthCookie, DateTime.Now.AddDays(-1), "")
        End If

        'Take wreply and build string to tell user the location they are logging out from.
        Dim wreply As String = Request.QueryString("wreply")

        Dim trimmedWreply As String = ""

        If (wreply.IsNullOrEmpty()) Then
            wreply = "a Federated Application"
            If Request.UrlReferrer IsNot Nothing Then
                Dim uriReferrer As Uri = New Uri(Request.UrlReferrer.ToString())
                trimmedWreply = uriReferrer.GetLeftPart(UriPartial.Authority)
                signoutLocation.Text = Request.UrlReferrer.ToString()
            End If
        Else
            Dim decodedWreply As String = HttpUtility.UrlDecode(wreply)
            Dim uriWreply = New Uri(decodedWreply)
            trimmedWreply = uriWreply.GetLeftPart(UriPartial.Authority)
            signoutLocation.Text = trimmedWreply
        End If

       

        'Use the wreply to build the header text for the page. If comming from office 365 we try and set the text to Office 365, otherwise Federated Application
        'I need more cases for what the wreply uri can possibly contain from the logout event. However, in my testing, 90% of the time it will be from login.microsoftonline.com irregardless of where the signout command was initiated from on Office 365. 
        If trimmedWreply.Contains("microsoft") OrElse trimmedWreply.Contains("office365") OrElse trimmedWreply.Contains("outlook") OrElse trimmedWreply.Contains("onenote") OrElse trimmedWreply.Contains("office") Then
            appName.Text = "Office 365"
        Else
            appName.Text = "Federated Application"
        End If


    End Sub

End Class
